import { OnInit, EventEmitter, ElementRef, TemplateRef, AfterViewInit, OnDestroy } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { Ymd, NiDatetime, NiDatetimeLocale } from 'ni-datetime';
import { ValueChange, ViewDate, ViewMonth, LocaleChangeEvent, ViewUpdateEvent } from './ni-datetime-picker';
export declare class NiDatetimePickerComponent implements OnInit, AfterViewInit, OnDestroy, ControlValueAccessor {
    Locales: {
        fa_AF: {
            name: string;
            title: string;
            new: () => import("ni-datetime").NiJalaliDatetime;
            week: string;
            dir: string;
            firstday: number;
            weekends: number[];
            daysName: string[];
            daysNameShort: string[];
            daysNameMini: string[];
            monthsName: string[];
            monthsNameShort: string[];
            ampm: string[];
            AMPM: string[];
            today: string;
            clear: string;
        };
        ps_AF: {
            name: string;
            title: string;
            new: () => import("ni-datetime").NiJalaliDatetime;
            week: string;
            dir: string;
            firstday: number;
            weekends: number[];
            daysName: string[];
            daysNameShort: string[];
            daysNameMini: string[];
            monthsName: string[];
            monthsNameShort: string[];
            ampm: string[];
            AMPM: string[];
            today: string;
            clear: string;
        };
        fa_IR: {
            name: string;
            title: string;
            new: () => import("ni-datetime").NiJalaliDatetime;
            week: string;
            dir: string;
            firstday: number;
            weekends: number[];
            daysName: string[];
            daysNameShort: string[];
            daysNameMini: string[];
            monthsName: string[];
            monthsNameShort: string[];
            ampm: string[];
            AMPM: string[];
            today: string;
            clear: string;
        };
        ar_SA: {
            name: string;
            title: string;
            new: () => import("../../../../dist/libs/ni-datetime/lib/ni-datetime").NiIslamicDatetime;
            week: string;
            dir: string;
            firstday: number;
            weekends: number[];
            daysName: string[];
            daysNameShort: string[];
            daysNameMini: string[];
            monthsName: string[];
            monthsNameShort: string[];
            ampm: string[];
            AMPM: string[];
            today: string;
            clear: string;
        };
        en_US: {
            name: string;
            title: string;
            new: () => import("ni-datetime").NiGregorianDatetime;
            week: string;
            dir: string;
            firstday: number;
            weekends: number[];
            daysName: string[];
            daysNameShort: string[];
            daysNameMini: string[];
            monthsName: string[];
            monthsNameShort: string[];
            ampm: string[];
            AMPM: string[];
            today: string;
            clear: string;
        };
    };
    localeTitle(locale: string): any;
    _inited: boolean;
    onChange: (value: any) => void;
    onTouched: () => void;
    __disabled: boolean;
    set disabled(value: boolean);
    get disabled(): boolean;
    __value: any;
    set value(value: any);
    get value(): any;
    _firstDateValue(value: any): any;
    _dateORarray(value: any): any;
    _dateArray(value: any): any[];
    valueChange: EventEmitter<any>;
    valueChanged: EventEmitter<ValueChange | ValueChange[]>;
    _setValue(value: any, emit?: boolean): void;
    defaultDate: Date;
    __monthPicker: boolean;
    __prevNumberOfMonths: any;
    set monthPicker(value: boolean);
    get monthPicker(): boolean;
    __datePicker: boolean;
    set datePicker(value: boolean);
    get datePicker(): boolean;
    __timePicker: boolean;
    set timePicker(value: boolean);
    get timePicker(): boolean;
    __inline: boolean;
    set inline(value: boolean);
    get inline(): boolean;
    __locales: string[];
    set locales(locales: string[]);
    get locales(): string[];
    showLocaleSwitch: boolean;
    __locale: NiDatetimeLocale;
    localeChange: EventEmitter<string>;
    set locale(value: any);
    get locale(): any;
    _getFormatted(format: string, value: any): string;
    monthDateLocales: any[];
    __inputFormat: string;
    set inputFormat(value: string);
    get inputFormat(): string;
    _updateInputfield(): void;
    placeholder: string;
    __titleFormat: string;
    set titleFormat(value: string);
    get titleFormat(): string;
    _updateTitle(): void;
    __monthHeaderFormat: string;
    set monthHeaderFormat(value: string);
    get monthHeaderFormat(): string;
    picker: any;
    modal: any;
    dialog: any;
    appendTo: any;
    showed: EventEmitter<any>;
    hidded: EventEmitter<any>;
    focused: EventEmitter<any>;
    blurred: EventEmitter<any>;
    viewUpdated: EventEmitter<ViewUpdateEvent>;
    localeChanged: EventEmitter<LocaleChangeEvent>;
    dialogWidth: string;
    monthWidth: string;
    __numberOfMonths: number;
    set numberOfMonths(value: number);
    get numberOfMonths(): number;
    __computeUiElementsWidth(): void;
    __disabledDates: Date[];
    set disabledDates(value: Date[]);
    get disabledDates(): Date[];
    showWeekNums: boolean;
    __disableWeekends: boolean;
    set disableWeekends(value: boolean);
    get disableWeekends(): boolean;
    get _todayDate(): Date;
    calendar: NiDatetime;
    get _today(): Ymd;
    __selectedSeparator: string;
    set selectedSeparator(value: string);
    get selectedSeparator(): string;
    __checkSelectedSeparator(): void;
    __selectionMode: string;
    set selectionMode(value: string);
    get selectionMode(): string;
    get isSingleSelection(): boolean;
    get isMultipleSelection(): boolean;
    get isRangeSelection(): boolean;
    _inputFormatted: string;
    __openDialog: boolean;
    set openDialog(value: boolean);
    get openDialog(): boolean;
    __dialogDetached: boolean;
    __detachDialog(): void;
    __attachDialog(): void;
    __manageOverlay(): void;
    showPickerIcon: boolean;
    showClearBtn: boolean;
    clearBtnText: any;
    showTodayBtn: boolean;
    todayBtnText: any;
    todayBtnSet: string;
    showYearNavigator: boolean;
    yearNavigatorRange: string;
    __yearNavRange: string;
    __yearNavValues: any[];
    get yearNavValues(): any[];
    showMonthNavigator: boolean;
    get monthNavigatorValues(): string[];
    get _navYear(): number;
    set _navYear(year: number);
    get _navMonth(): number;
    set _navMonth(month: number);
    __navYmChanged(year: number, month: number): void;
    _title: string;
    _viewMonthsMin: Date;
    _viewMonthsMax: Date;
    _viewMonths: ViewMonth[];
    titleDefaultTemplate: TemplateRef<ElementRef>;
    titleTemplate: TemplateRef<ElementRef>;
    get _titleTemplate(): TemplateRef<ElementRef<any>>;
    monthDateDefaultTemplate: TemplateRef<ElementRef>;
    monthDateTemplate: TemplateRef<ElementRef>;
    get _mdateTemplate(): TemplateRef<ElementRef<any>>;
    monthFooterDefaultTemplate: TemplateRef<ElementRef>;
    monthFooterTemplate: TemplateRef<ElementRef>;
    get _mfooterTemplate(): TemplateRef<ElementRef<any>>;
    monthTitleDefaultTemplate: TemplateRef<ElementRef>;
    monthTitleTemplate: TemplateRef<ElementRef>;
    get _mtitleTemplate(): TemplateRef<ElementRef<any>>;
    navByScroll: boolean;
    navByTouch: boolean;
    __targetTimezoneUTCOffset: any;
    set targetTimezoneUTCOffset(offset: number);
    get targetTimezoneUTCOffset(): number;
    constructor();
    writeValue(obj: any): void;
    registerOnChange(fn: (value: any) => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState?(isDisabled: boolean): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    __copy(dates: any): any;
    _inputFocused($event: any): void;
    _inputBlured($event: any): void;
    _navToPreviousView(): void;
    _navToNextView(): void;
    _scrollIncrement($event: any): number;
    __touchStart: any;
    __unify(e: any): any;
    _logTouchStart($event: any): void;
    _touchIncrement($event: any): 0 | 1 | -1;
    _navBy(increment: number): void;
    _todayClicked($event: any): void;
    _monthDateClicked(viewDate: ViewDate): void;
    _selectMonthDate(viewDate: ViewDate): void;
    __ymdInt(ymd: Ymd): number;
    __isYmdInRange(value: ViewDate, first: ViewDate, last?: ViewDate): boolean;
    __viewDateStateHelper(): {
        today: Ymd;
        calendar: NiDatetime;
        selected: (date: ViewDate) => boolean;
    };
    __updateViewDatesStates(): void;
    __updateViewDateState(date: ViewDate, helpers: any): void;
    __updateView(force?: boolean, emit?: boolean): void;
    __computeMonthDates(ndate: NiDatetime): ViewMonth;
    private _attachRequestedLocales;
    __getNumberOfWeeksUntil(calendar: NiDatetime, month: number): number;
    __getFirstdaysDiff(locale1stday: number, week1stday: number): number;
    _updateTime(): void;
    _overlayClicked($event: any): void;
    _pickerClicked($event: any): void;
    _clearClicked($event: any): void;
    _updateLocale(locale: any, emit?: boolean): void;
    _pad(num: number, length: number): string;
}
